【LeetCode】947. Most Stones Removed with Same Row or Column 移除最多的同行或同列石头(Medium)(JAVA)每日一题

【LeetCode】947. Most Stones Removed with Same Row or Column 移除最多的同行或同列石头(Medium)(JAVA)

题目地址: https://leetcode.com/problems/minimum-increment-to-make-array-unique/

题目描述:

On a 2D plane, we place n stones at some integer coordinate points. Each coordinate point may have at most one stone.

A stone can be removed if it shares either the same row or the same column as another stone that has not been removed.

Given an array stones of length n where stones[i] = [xi, yi] represents the location of the ith stone, return the largest possible number of stones that can be removed.

Example 1:

Input: stones = [[0,0],[0,1],[1,0],[1,2],[2,1],[2,2]]
Output: 5
Explanation: One way to remove 5 stones is as follows:
1. Remove stone [2,2] because it shares the same row as [2,1].
2. Remove stone [2,1] because it shares the same column as [0,1].
3. Remove stone [1,2] because it shares the same row as [1,0].
4. Remove stone [1,0] because it shares the same column as [0,0].
5. Remove stone [0,1] because it shares the same row as [0,0].
Stone [0,0] cannot be removed since it does not share a row/column with another stone still on the plane.

Example 2:

Input: stones = [[0,0],[0,2],[1,1],[2,0],[2,2]]
Output: 3
Explanation: One way to make 3 moves is as follows:
1. Remove stone [2,2] because it shares the same row as [2,0].
2. Remove stone [2,0] because it shares the same column as [0,0].
3. Remove stone [0,2] because it shares the same row as [0,0].
Stones [0,0] and [1,1] cannot be removed since they do not share a row/column with another stone still on the plane.

Example 3:

Input: stones = [[0,0]]
Output: 0
Explanation: [0,0] is the only stone on the plane, so you cannot remove it.

Constraints:

  • 1 <= stones.length <= 1000
  • 0 <= xi, yi <= 10^4
  • No two stones are at the same coordinate point.

题目大意

n 块石头放置在二维平面中的一些整数坐标点上。每个坐标点上最多只能有一块石头。

如果一块石头的 同行或者同列 上有其他石头存在,那么就可以移除这块石头。

给你一个长度为 n 的数组 stones ,其中 stones[i] = [xi, yi] 表示第 i 块石头的位置,返回 可以移除的石子 的最大数量。

扫描二维码关注公众号,回复: 12599903 查看本文章

解题方法

  1. 采用并查集
  2. 如果 x 没有在集合里出现过,个数加一;把 [x, y] 的 x 和 y 关联起来,个数减一;
  3. note: 因为不确定 x 和 y 轴的最大数量,所以采用 map 的方式来存 x 的 father 节点;因为 xi, yi <= 10^4,所以可以对 xi 和 yi 加上 10001 来避免 x 和 y 的重复
class Solution {
    public int removeStones(int[][] stones) {
        UnionFind unionFind = new UnionFind();
        for (int i = 0; i < stones.length; i++) {
            unionFind.merge(stones[i][0], stones[i][1] + 10001);
        }
        return stones.length - unionFind.getCount();
    }

    public class UnionFind {
        private Map<Integer, Integer> map = new HashMap<>();
        private int count = 0;
        
        public int getCount() {
            return count;
        }
        
        public int find(int x) {
            if (!map.containsKey(x)) {
                map.put(x, x);
                count++;
            }
            int fatherX = map.get(x);
            if (fatherX != x) {
                map.put(x, find(fatherX));
            }
            return map.get(x);
        }
        
        public void merge(int x, int y) {
            int fatherX = find(x);
            int fatherY = find(y);
            if (fatherX == fatherY) return;
            map.put(fatherX, fatherY);
            count--;
        }
    }
}

执行耗时:9 ms,击败了69.65% 的Java用户
内存消耗:38.9 MB,击败了35.53% 的Java用户

欢迎关注我的公众号,LeetCode 每日一题更新

猜你喜欢

转载自blog.csdn.net/qq_16927853/article/details/112647387